#include <iostream>
using namespace std;
long long a[100000];
bool polz[10000];
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long N,dr=0,nen=0;
    cin>>N;
    for(long long i=0; i<N; i++)
    {
        cin>>a[i];
    }
    for(long long i=0; i<N; i++)
    {
        if((a[i]>a[i+1] && a[i]>a[i-1]) || (a[i]<a[i+1] && a[i]<a[i-1]))
        {
            if(nen==0)
            {
                dr+=i*(N-i-1);
            }
            else
            {
                dr+=2;
            }
            nen++;
        }
    }
    cout<<N*(N-1)-dr*2;
    return 0;
}
